class iaas::profile::ceilometer::controller (
  $password = hiera('iaas::profile::ceilometer::password', undef),
  $servers = hiera('iaas::profile::ceilometer::servers', undef),

  $public_interface = hiera('iaas::public_interface', undef),
  $admin_interface = hiera('iaas::admin_interface', undef),

  $region = hiera('iaas::region', undef),

  $zookeeper_id = undef,
  $zookeeper_max_connections = 128,

  $coordination_ip = hiera('iaas::role::endpoint::coordination', undef),

#VIP1
  $endpoint_main = hiera('iaas::main_address', undef),
#VIP2
  $endpoint_admin = hiera('iaas::admin_address', undef),

) {
  include iaas::resources::connectors

##Leave commented if DB is not controller
#  iaas::resources::database { 'ceilometer': }

  include iaas::profile::ceilometer::common

  $admin_ip = $::facts["ipaddress_${admin_interface}"]

  class { '::ceilometer::keystone::auth':
    password => $password,
    public_address => $endpoint_main,
    admin_address => $endpoint_admin,
    internal_address => $endpoint_admin,
    region => $region,
  }

  class { '::ceilometer::api':
    keystone_host => $endpoint_admin,
    enabled => true,
    keystone_password => $password,
    keystone_auth_uri => "http://${endpoint_main}:5000/v2.0",
##Identity_uri planned to be inplemented
#    keystone_identity_uri => "http://${endpoint_admin}:35357",
  }

  class { '::ceilometer::db':
    database_connection => $iaas::resources::connectors::ceilometer,
    mysql_module => '2.3',
  }

  package { 'python-zake': }

  class { 'zookeeper':
    id => $zookeeper_id,
    client_ip => $::facts["ipaddress_${admin_interface}"],
    servers => $servers,
    max_allowed_connections => $zookeeper_max_connections,
  }

  class { '::ceilometer::agent::central':
    coordination_url => "kazoo://${$coordination_ip}",
  }

  class { '::ceilometer::alarm::evaluator':
    coordination_url => "kazoo://${$coordination_ip}",
  }

  class { '::ceilometer::expirer':
    time_to_live => '2592000',
  }

  class { '::ceilometer::alarm::notifier': }
  class { '::ceilometer::collector': }
  class { '::ceilometer::agent::notification': }

}
