class iaas::profile::heat (
  $password = hiera('iaas::profile::heat::password', undef),
  $encryption_key = hiera('iaas::profile::heat::encryption_key', undef),
  $public_interface = hiera('iaas::public_interface', undef),
  $admin_interface = hiera('iaas::admin_interface', undef),

##verbose, debug
  $verbose = hiera('iaas::verbose', undef),
  $debug = hiera('iaas::debug', undef),

  $region = hiera('iaas::region', undef),

#VIP1
  $endpoint_main = hiera('iaas::main_address', undef),
#VIP2
  $endpoint_admin = hiera('iaas::admin_address', undef),

##rhosts
  $endpoint = hiera('iaas::main_address', undef),
  $rhosts = hiera('iaas::profile::rabbitmq::rhosts', undef),
  $rabbitmq_user = hiera('iaas::profile::rabbitmq::user', undef),
  $rabbitmq_password = hiera('iaas::profile::rabbitmq::password', undef),
) {
  include iaas::resources::connectors

##Leave commented if DB is not controller
#  iaas::resources::database { 'heat': }

  class { '::heat::keystone::auth':
    password => $password,
    public_address => $endpoint_main,
    admin_address => $endpoint_admin,
    internal_address => $endpoint_admin,
    region => $region,
  }
  class { '::heat::keystone::auth_cfn':
    password => $password,
    public_address => $endpoint_main,
    admin_address => $endpoint_admin,
    internal_address => $endpoint_admin,
    region => $region,
  }

  class { '::heat':
##verbose, debug
    verbose => $verbose,
    debug => $debug,
    database_connection => $iaas::resources::connectors::heat,
##rabbit_hosts - uncomment as needed
#    rabbit_host => $endpoint,
    rpc_backend => "rabbit",
    rabbit_hosts => $rhosts,
    rabbit_userid => $rabbitmq_user,
    rabbit_password => $rabbitmq_password,
    auth_uri => "http://${endpoint_main}:5000/v2.0",
##Identity_uri - planed to be implemented#
#    identity_uri => "http://${endpoint_admin}:35357",
    keystone_host => $endpoint_admin,
    keystone_password => $password,
    mysql_module => '2.3',
    database_idle_timeout => 3600,
#    region_name => $region,
    keystone_ec2_uri => "http://${endpoint_main}:5000/v2.0",
  }

  class { '::heat::api':
    bind_host => $::facts["ipaddress_${admin_interface}"],
  }
  class { '::heat::api_cfn':
    bind_host => $::facts["ipaddress_${admin_interface}"],
  }
  class { '::heat::api_cloudwatch': 
    bind_host => $::facts["ipaddress_${admin_interface}"],
  }

  class { '::heat::engine':
    auth_encryption_key => $encryption_key,
    heat_metadata_server_url => "http://${endpoint_main}:8000",
    heat_waitcondition_server_url => "http://${endpoint_main}:8000/v1/waitcondition",
    heat_watch_server_url => "http://${endpoint_main}:8003",
  }

  file { "/usr/bin/heat-keystone-setup-domain":
      mode   => 550,
      owner  => root,
      group  => root,
      source => "puppet:///modules/iaas/heat-keystone-setup-domain"
  } ->

  class { 'heat::keystone::domain':
    auth_url => "http://${endpoint_admin}:35357/v2.0",
    keystone_admin => "heat",
    keystone_password => $password,
    keystone_tenant   => "services",
    domain_name => 'heat',
    domain_admin => 'heat_domain_admin',
    domain_password => 'heat_admin',
  }

  heat_config {
    'keystone_authtoken/identity_uri' :value => "http://${endpoint_admin}:35357";
  }

}
